## draw wave
## Copyright Hong-Chi SHih May 2013
## May 2013
## Compatible Python 3.3.x

import math
import random
from BMP import BMP

################################### 
def main():
    #image width
    Width = 256
    #image height
    Height = 256
    
    #frame maximum
    max_frame = 15
    
    #wave transfer rate
    rate = 5;
    
    for frame in range(0, (max_frame*rate), rate):
        s = BMP("wave{0}.bmp".format((int(frame/rate))+1))
        s.setWidth(Width)
        s.setHeight(Height)
        s.genEmptyBMP()
        #draw image
        for x in range(0, s.getWidth()):
            for y in range(0, s.getHeight()):
                #draw water color
                s.setPixel(x, y, 132, 193, 255)
        
        radius = 5 + frame
        radius_range = 5
        
        #draw wave circle 
        for range_index in range(0, radius_range):
            for theta in range(0, 360, 2):
                #circle radius
                rn = radius + range_index
                #random wave angle
                r_angle = theta + random.random();
                x = int(rn * math.cos(r_angle)) + int(Width/2)
                y = int(rn * math.sin(r_angle)) + int(Height/2)
                #draw wave
                if(x>0 and y>0 and x<Width and y<Height):
                    s.setPixel(x, y, (132+range_index*5), (193+range_index*5), 255)
                
        s.writeBMP()
###################################  

if __name__ == '__main__':
    main()
    print("done")